<template>

  <!-- 主体部分 -->
  <div class="xl:w-screen-xl m-auto py-4 mt-20">
    <el-page-header :icon="ArrowLeft" @back="goBack">
      <template #content>
        <span class="text-large font-600"> 相关插件 </span>
      </template>
      <template #extra>
        <el-space class="flex items-center">
          <el-select v-model="value" clearable placeholder="类型" style="width: 180px" @change="onTypes">
            <el-option
              v-for="item in types"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            />
          </el-select>
<!--          <el-button-group v-model:value="where" @tab-click="handleClick" @change="reload">-->
<!--            <el-button>综合</el-button>-->
<!--            <el-button>最新</el-button>-->
<!--            <el-button>免费</el-button>-->
<!--            <el-button>付费</el-button>-->
<!--          </el-button-group>-->
          <el-input v-model="where.keywords" style="width: 400px" :placeholder="`插件ID | 插件名称 | 域名`" :suffix-icon="Search" @change="reload"/>
        </el-space>
      </template>
      <el-row :gutter="24" id="container" class="clearfix">
        <el-col v-for="(item,index) in list" :key="index" :span="8" class="left mb-8">
          <el-card shadow="hover" :body-style="{ padding: '0px' }" class="cursor-pointer" @mouseover="showDomain(item)" @mouseleave="hideDomain" @click="navigateTo(`/market/${item.websiteId}.html`)">
            <div class="flex-1 px-4 py-5 sm:p-4 !p-4">
              <div class="text-gray-700 dark:text-white text-base font-semibold  flex gap-1.5">
                <el-avatar
                    :src="item.websiteLogo" shape="square" :size="55" style="background-color: white;"/>
                <div class="flex-1 text-lg cursor-pointer flex flex-col">
                  {{ item.websiteName }}
                  <div class="flex justify-between items-center">
                    <sapn class="text-xs text-gray-400 font-normal line-clamp-1">
                      {{ id == item.websiteId ? item.domain : item.comments || '暂无描述' }}
                    </sapn>
                    <el-button size="small" round>获取</el-button>
                  </div>
                </div>
              </div>
              <div class="item-image pt-3">
                <el-image v-if="item.files" :src="`${JSON.parse(item.files)[0]}`" class="w-full h-1/2 max-h-[220px]" />
                <el-image v-else class="w-full h-[220px]" />
              </div>
            </div>
          </el-card>
        </el-col>
      </el-row>
    </el-page-header>

    <Pagination :total="total" @done="search" />
  </div>

</template>
<script setup lang="ts">

import { Picture as IconPicture } from '@element-plus/icons-vue'
import { ArrowLeft,View,Search } from '@element-plus/icons-vue'
import { ElNotification as notify } from 'element-plus'
import { useLayout, usePage} from "~/composables/configState";
import type {CmsNavigation} from "~/api/cms/cmsNavigation/model";
import type {CmsArticleParam} from "~/api/cms/cmsArticle/model";
import type { ComponentSize } from 'element-plus'
import { ElNotification } from 'element-plus'
import type { TabsPaneContext } from 'element-plus'
import dayjs from "dayjs";
import {getCmsNavigation, listCmsNavigation} from "~/api/cms/cmsNavigation";
import {pageCmsArticle} from "~/api/cms/cmsArticle";
import {pageCmsWebsiteAll} from "~/api/cms/cmsWebsite";
import type {CmsWebsite, CmsWebsiteParam} from "~/api/cms/cmsWebsite/model";

const route = useRoute();
const router = useRouter();
const navId = ref();
// 页面信息
const list = ref<CmsWebsite[]>([]);
const i18n = useI18n();
const category = ref<CmsNavigation[]>([]);
const total = ref(0);
const activeName = ref('2839');
const id = ref<number>();

// 获取状态
const page = usePage();
const layout = useLayout();

// 搜索表单
const where = reactive<CmsWebsiteParam>({
  keywords: '',
  page: 1,
  limit: 12,
  status: undefined,
  recommend: undefined,
  market: true,
  websiteType: undefined,
  categoryId: undefined,
  userId: undefined,
  lang: undefined
});

const types = [
  {
    value: '网站',
    label: '网站',
  },
  {
    value: '小程序',
    label: '小程序',
  },
  {
    value: 'MacOS',
    label: 'MacOS',
  },
  {
    value: 'Windows',
    label: 'Windows',
  },
  {
    value: 'App',
    label: 'App',
  },
]

const goBack = () => {
  router.back();
}
const showDomain = (item: CmsWebsite) => {
  id.value = Number(item.websiteId);
};

const hideDomain = () => {
  id.value = 0;
};

// 加载页面数据
const reload = async () => {
  await pageCmsWebsiteAll(where).then(response => {
    if(response?.list){
      list.value = response?.list;
      total.value = response.count;
    }
  }).catch(() => {})
}

const bakReload = async () => {
  await getCmsNavigation(navId.value).then(data => {
    page.value = data;
    layout.value.banner = data.banner;

    // seo
    useSeoMeta({
      description: data.comments || data.title,
      keywords: data.title,
      titleTemplate: `${data?.title}` + ' - %s',
    })

    // 二级栏目分类
    listCmsNavigation({
      parentId: data.parentId == 0 ? data.navigationId : data.parentId
    }).then(navigation => {
      category.value = navigation;
      // 加载文章列表
      if(data.parentId == 0 && category.value.length > 0){
        where.parentId = page.value.navigationId;
      }else {
        where.categoryId = page.value.navigationId;
      }
      pageCmsArticle(where).then(response => {
        if(response){
          total.value = response.count;
          list.value = response.list;
        }
      })
    })
  }).catch(() => {})

}

/**
 * 搜索
 * @param data
 */
const search = (data: CmsArticleParam) => {
  where.page = data.page;
  reload();
}

const handleClick = (tab: TabsPaneContext, event: Event) => {
  console.log(tab, event)
}
const value = ref('')

const onTypes = (value: string) => {
  where.websiteType = value;
  reload();
}

watch(
    () => route.params.id,
    (id) => {
      where.userId = getNavIdByParamsId(id);
      reload();
    },
    { immediate: true }
);
</script>
<style lang="scss">
.right .content img{
  width: auto !important;
}
.demo-tabs > .el-tabs__content {
  padding: 32px;
  color: #6b778c;
  font-size: 32px;
  font-weight: 600;
}
</style>


